package visualDB;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;

import javax.swing.JOptionPane;

public class CreateOracleToMysqlTable {

	DBConnectionKisun pool=null;
	DBKisunOracle ora_pool=null;
	Connection conn=null;
	Statement stmt=null;
	ResultSet rs = null;
	ResultSetMetaData rsmd=null;
	String query;

	/**
	 * ο Ÿ Ÿ 175columnType޼ҵ switch ߰Ű 
	 * 117 ColumnSize  Ⱦ  .
	 */
	

	CreateOracleToMysqlTable(OracleLoginData ora_log, MysqlLoginData m_log, String oraTable, String mTable) throws Exception{
		// db, ip, portȣ, db, user,  
			ora_pool = DBKisunOracle.getInstance(ora_log.getOracle_ip(), ora_log.getOracle_port(), ora_log.getOracle_dbname(), ora_log.getOracle_id(), ora_log.getOracle_pw());
			conn = ora_pool.getConnection();
			stmt = conn.createStatement();
			
			String str = makeTable(oraTable, mTable);
			System.out.println(str);

			if(conn != null)
			{
				ora_pool.freeConnection(conn, stmt);
			}
			
			
			pool = DBConnectionKisun.getInstance("mysql",m_log.getM_ip(), m_log.getM_port(), m_log.getM_dbName(), m_log.getM_id(),m_log.getM_pw());
			conn = pool.getConnection();
			stmt = conn.createStatement();
						
			stmt.execute(str);		//̺ 

			System.out.println("̺ Ϸ");
			
			query="show tables";
			rs = stmt.executeQuery(query);
			while(rs.next())
			System.out.println(rs.getString(1));
			
			if(conn != null)
			{
				pool.freeConnection(conn, stmt);
			}
			
		
	}
	
	
	
	CreateOracleToMysqlTable(){
	}
	
	public String makeTable(String table, String newTable)
	{
		query="select * from "+table;	
		String create_table = "create table "+newTable+"(";
		
		try {
			rs = stmt.executeQuery(query);
			rsmd = rs.getMetaData(); 
			System.out.println("getTableName  : "+rsmd.getTableName(1));
			int columnCount = rsmd.getColumnCount();
			System.out.println("columnCount : "+columnCount);
			int a=1;
			while(a<=columnCount)
			{
				System.out.println("----------------- ");
				System.out.print("\tgetCatalogName : "+rsmd.getColumnName(a));
				create_table =create_table+ checkName(rsmd.getColumnName(a))+" ";	//++++++++++ ʵ  +++++++++++++++++++++
				System.out.print("\tgetColumnTypeName : "+rsmd.getColumnTypeName(a));
				
				
				System.out.print("\tgetColumnType : "+rsmd.getColumnType(a));
				System.out.print("\tgetPrecision(10ڸ) : "+rsmd.getPrecision(a));				
				System.out.print("\tgetScale(Ҽ) : "+rsmd.getScale(a));
				if(rsmd.getColumnTypeName(a).toUpperCase().equals("NUMBER"))
				{
					if(rsmd.getScale(a)<=0)
						create_table = create_table + "int("+rsmd.getColumnDisplaySize(a)+")";
					else
						create_table = create_table+" float ";
				}else if(rsmd.getColumnTypeName(a).toUpperCase().equals("VARCHAR2") && rsmd.getColumnDisplaySize(a)>255 )
				{
					create_table =create_table+ " text ";
				}else
				{					
					create_table =create_table+ columnType(rsmd.getColumnType(a));	//++++++++++ ColumnType  +++++++++++++++++++++
					System.out.print("\tgetColumnDisplaySize : "+rsmd.getColumnDisplaySize(a));
					if(rsmd.getColumnType(a)!=-1 && rsmd.getColumnType(a)!= 91 )	// long(text)Ÿ,dateŸ Size
						create_table =create_table+"("+ rsmd.getColumnDisplaySize(a)+")";	//++++++++++ ColumnSize  +++++++++++++++++++++
				}
				if(rsmd.isAutoIncrement(a))
					System.out.print("\tautoIncrement");
				if(rsmd.isNullable(a)==ResultSetMetaData.columnNoNulls)
				{
					System.out.println("\tNo Null");
					create_table =create_table+ " not null ";	//++++++++++ not null  ++++++++++++++++
				}
				else if(rsmd.isNullable(a)==ResultSetMetaData.columnNullable)
					System.out.println("\tNull Able");
				else if(rsmd.isNullable(a)==ResultSetMetaData.columnNullableUnknown)
					System.out.println("\tNull Don't know");

				if(a!=columnCount)
				create_table =create_table+ ", ";	//++++++++++ comma  ++++++++++++++++
				
				a++;
			}
			
			DatabaseMetaData md = conn.getMetaData();
			ResultSet rs1 = md.getPrimaryKeys(null, null, table.toUpperCase());
			if(rs1.next())
			{
				create_table =create_table+", primary key("+rs1.getString(4)+"))";	//+++++++++++++++++++++++++++++++
			}else
			{

				create_table =create_table+")";	//+++++++++++++ primary key ++++++++++++++++++
			}
			
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		return create_table;
	}
		
	private String checkName(String columnName) {
		String check_str=columnName.toUpperCase();
		String booking[] ={"ADD", "ALL", "ALTER", "ANALYZE", "AND", "AS", "ASC", "ASENSITIVE", "BEFORE",  
				"BETWEEN", "BIGINT", "BINARY", "BLOB", "BOTH", "BY", "CALL", "CASCADE", "CASE", "CHANGE", 
				"CHAR", "CHARACTER", "CHECK", "COLLATE", "COLUMN", "CONDITION", "CONNECTION", "CONSTRAINT", 
				"CONTINUE", "CONVERT", "CREATE", "CROSS", "CURRENT_DATE", "CURRENT_TIME", "CURRENT_TIMESTAMP", 
				"CURRENT_USER", "CURSOR", "DATABASE", "DATABASES", "DAY_HOUR", "DAY_MICROSECOND", 
				"DAY_MINUTE", "DAY_SECOND", "DEC", "DECIMAL", "DECLARE", "DEFAULT", "DELAYED", "DELETE", 
				"DESC", "DESCRIBE", "DETERMINISTIC", "DISTINCT", "DISTINCTROW", "DIV", "DOUBLE", "DROP", "DUAL",  
				"EACH", "ELSE", "ELSEIF", "ENCLOSED", "ESCAPED", "EXISTS", "EXIT", "EXPLAIN", "FALSE",  
				"FETCH", "FLOAT", "FLOAT4", "FLOAT8", "FOR", "FORCE", "FOREIGN", "FROM", "FULLTEXT", "GOTO", 
				"GRANT", "GROUP", "HAVING", "HIGH_PRIORITY", "HOUR_MICROSECOND", "HOUR_MINUTE", "HOUR_SECOND", 
				"IF", "IGNORE", "IN", "INDEX", "INFILE", "INNER", "INOUT", "INSENSITIVE", "INSERT", "INT", "INT1", 
				"INT2", "INT3", "INT4", "INT8", "INTEGER", "INTERVAL", "INTO", "IS", "ITERATE", "JOIN", "KEY",  
				"KEYS", "KILL", "LABEL", "LEADING", "LEAVE", "LEFT", "LIKE", "LIMIT", "LINES", "LOAD", "LOCALTIME", 
				"LOCALTIMESTAMP", "LOCK", "LONG", "LONGBLOB", "LONGTEXT", "LOOP", "LOW_PRIORITY", "MATCH", 
				"MEDIUMBLOB", "MEDIUMINT", "MEDIUMTEXT", "MIDDLEINT", "MINUTE_MICROSECOND", "MINUTE_SECOND", 
				"MOD", "MODIFIES", "NATURAL", "NOT", "NO_WRITE_TO_BINLOG", "NULL", "NUMERIC", "ON", "OPTIMIZE", 
				"OPTION", "OPTIONALLY", "OR", "ORDER", "OUT", "OUTER", "OUTFILE", "PRECISION", "PRIMARY", 
				"PROCEDURE", "PURGE", "RAID0", "READ", "READS", "REAL", "REFERENCES", "REGEXP", "RELEASE", 
				"RENAME", "REPEAT", "REPLACE", "REQUIRE", "RESTRICT", "RETURN", "REVOKE", "RIGHT", "RLIKE", 
				"SCHEMA", "SCHEMAS", "SECOND_MICROSECOND", "SELECT", "SENSITIVE", "SEPARATOR", "SET", "SHOW", 
				"SMALLINT", "SONAME", "SPATIAL", "SPECIFIC", "SQL", "SQLEXCEPTION", "SQLSTATE", "SQLWARNING", 
				"SQL_BIG_RESULT", "SQL_CALC_FOUND_ROWS", "SQL_SMALL_RESULT", "SSL", "STARTING", "STRAIGHT_JOIN TABLE", 
				"TERMINATED", "THEN", "TINYBLOB", "TINYINT", "TINYTEXT", "TO", "TRAILING", "TRIGGER", "TRUE", "UNDO", 
				"UNION", "UNIQUE", "UNLOCK", "UNSIGNED", "UPDATE", "USAGE", "USE", "USING", "UTC_DATE", "UTC_TIME", 
				"UTC_TIMESTAMP", "VALUES", "VARBINARY", "VARCHAR", "VARCHARACTER", "VARYING", "WHEN", "WHERE", 
				"WHILE", "WITH", "WRITE", "X509", "XOR", "YEAR_MONTH", "ZEROFILL"};
		for(int i=0;i<booking.length;i++)
		{
			if(check_str.equals(booking[i]))
				check_str=JOptionPane.showInputDialog(booking[i]+" MySQL  ȵ \n ʵ Էּ(̸ ٲ Ÿ, )");	
			// ȵǴ ̸ ޽ڽ Է¹ޱ 
		}
		return check_str;
	}

	private String columnType(int columnType) {
		String col_type="";
		
		switch(columnType)
		{
		case 2 : col_type="int";	break;	// number
		case 12: col_type="varchar";	break;	// string
		case -1: col_type="text";	break;	// long
		case 5: col_type="small_int";	break;	// small_int
		case 91: col_type="date";	break;	// date
		
		case 4: col_type="number";	break;	// int
		case 1: col_type="char";	break;	// char
		default : col_type="default"; 	break;
		}
		
		return col_type;
	}

	public static void main(String[] args) {
		new CreateOracleToMysqlTable();
	}
}
