package visualDB;



import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Point;
import java.awt.Rectangle;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.SwingUtilities;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.table.DefaultTableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;





public class MainFrm extends JFrame {

	/**
	 * 
	 *  ʿؼ  ޼ҵ 160
	 * mysql : 192.168.0.25, 3306, root, -, mydb
	 * oracle : 192.168.0.13, 1521, hr, hr, XE
	 * 
	 */
	
	private static final long serialVersionUID = 1L;

	private JPanel jContentPane = null;

	private JPanel mysqlPanel = null;

	private JLabel lb_ip = null;

	private JLabel lb_port = null;

	private JLabel lb_ID = null;

	private JLabel lb_pw = null;

	private JLabel lb_DB = null;

	private JTextField mysql_ip = null;

	private JTextField mysql_port = null;

	private JTextField mysql_id = null;

	private JPasswordField mysql_pw = null;

	private JTextField mysql_dbname = null;

	private JButton mysql_conn = null;

	private JButton mysql_exit = null;

	private JLabel mysql_title = null;

	private JTree mysqlTree = null;

	private JPanel mysql_card = null;

	private JTabbedPane mysqlTab = null;

	private JScrollPane mysqlType = null;

	private JTable mysqlTypeTable = null;

	private JScrollPane mysqlDataScroll = null;

	private JTable mysqlDataTable = null;

	private JTextArea dbStatus = null;

	private JPanel OraclePanel = null;

	private JLabel jLabel = null;

	private JLabel jLabel1 = null;

	private JLabel jLabel2 = null;

	private JLabel jLabel3 = null;

	private JLabel jLabel4 = null;

	private JLabel jLabel5 = null;

	private JButton oracle_conn = null;

	private JButton oracle_exit = null;

	private JTextField oracle_ip = null;

	private JTextField oracle_port = null;

	private JTextField oracle_id = null;

	private JPasswordField oracle_pw = null;

	private JTextField oracle_dbname = null;

	private JTree oracleTree = null;

	private JTabbedPane oracleTab = null;

	private JScrollPane oracleTypeScroll = null;

	private JTable oracleType = null;

	private JScrollPane oracleDataScroll = null;

	private JTable oracleData = null;

	private JButton bt_MysqlToOracle = null;

	private JButton bt_OracleToMysql = null;

	
	
	/**
	 *  ʿؼ  
	 * MySQL_pool = DBConnectionKisun.getInstance("mysql", m_logData.getM_ip(), m_logData.getM_port(), m_logData.getM_dbName(), m_logData.getM_id(), m_logData.getM_pw());
	 */

	DBConnectionKisun MySQL_pool=null;
	Connection MySQL_conn=null;
	MysqlLoginData m_logData=null;
	
	DBKisunOracle Oracle_pool = null;
	Connection Oracle_conn=null;
	OracleLoginData ora_logData=null;
	
	
	
	MysqlTypeDefaultModel mtdm=null;
	MysqlDataDao m_dataDao=null;  //  @jve:decl-index=0:
	DefaultTableModel m_df_DataM=null;

	MysqlTypeDao m_typeDao=null;  //  @jve:decl-index=0:
	DefaultTableModel m_df_typeM=null;
	
	OracleDataDao ora_dataDao=null;  //  @jve:decl-index=0:
	DefaultTableModel ora_df_DataM=null;
	OracleTypeDao ora_typeDao=null;  //  @jve:decl-index=0:
	DefaultTableModel ora_df_TypeM=null;
	
	
	String query=null;  //  @jve:decl-index=0:
	Statement stmt=null;
	ResultSet rs = null;
	
	
	String m_ip = null;
	String m_port = null;
	String m_id = null;
	String m_pw = null;
	String m_dbName = null;
	
	String MysqlTable = null;
	boolean m_con_bl=false;
	
	String ora_ip = null;
	String ora_port = null;
	String ora_id = null;
	String ora_pw = null;
	String ora_dbName = null;

	String OracleTable = null;
	boolean ora_con_bl=false;
	
	
	Vector ora_tables = null;	// ̺   ̸ ̺ ִ ˻ϱ ؼ...  //  @jve:decl-index=0:
	Vector m_tables = null;  //  @jve:decl-index=0:	
	String moTable = null;
	String omTable = null;
	
	CreateMysqlToOracleTable create_moTable=null;
	InsertData_MysqlToOracle insert_moData=null;
	CreateOracleToMysqlTable create_omTable = null;
	InsertData_OracleToMysql insert_omData=null;
	
	
	DefaultTreeModel mTree_model=null;
	DefaultTreeModel oraTree_model=null;
	/**
	 *  ʿؼ  ޼ҵ
	 */
	public void setMysqlTree() {
		
		mTree_model = (DefaultTreeModel)mysqlTree.getModel();
		m_tables = new Vector();
		try {
			mTree_model.setRoot(mysql_TreeModel(MySQL_conn, m_dbName));
		} catch (Exception e) {
			System.out.println("Mysql Tree ");
			// e.printStackTrace();
		}	
		
		setMysqlTypeTable();
		setMysqlDataTable();
	}

	public DefaultMutableTreeNode mysql_TreeModel(Connection con, String dbName) throws Exception
	{
		DefaultMutableTreeNode parent = new DefaultMutableTreeNode(dbName);

		stmt = con.createStatement();
		
		query="show tables";
		rs = stmt.executeQuery(query);
		
		m_tables.clear();
		while(rs.next())
		{
			MysqlTable = rs.getString(1);
			m_tables.add(MysqlTable.toUpperCase());
			parent.add(new DefaultMutableTreeNode(MysqlTable));
		}
		
		
		return parent;		
	}
	
	Vector vType=null, vHeader=null;
	public void setMysqlTypeTable()
	{
		m_typeDao = new MysqlTypeDao(m_logData, MysqlTable);	

		vType = m_typeDao.getTypeDate();
		vHeader = m_typeDao.getTypeTitle();
		
		m_df_typeM = new DefaultTableModel(vType, vHeader);
		mysqlTypeTable.setModel(m_df_typeM);
		
		if(m_df_typeM!=null)
			m_typeDao.conClose();
	}
	
	Vector vData=null,vTitle=null;
	public void setMysqlDataTable()
	{
		m_dataDao = new MysqlDataDao(m_logData, MysqlTable);
	
		vData = m_dataDao.getMysqlData();
		vTitle = m_dataDao.getMysqlTitleData();
		m_df_DataM = new DefaultTableModel(vData, vTitle);
		mysqlDataTable.setModel(m_df_DataM);
		
		if(m_dataDao.conn!=null)
			m_dataDao.conClose();
	}

	public DefaultMutableTreeNode mysql_DisconnTreeModel() throws Exception
	{
		DefaultMutableTreeNode parent = new DefaultMutableTreeNode("MySQL DB");
		DefaultMutableTreeNode sun1 = new DefaultMutableTreeNode("");
		DefaultMutableTreeNode sun2 = new DefaultMutableTreeNode("̺");
		DefaultMutableTreeNode sun3 = new DefaultMutableTreeNode("ϼ");
		parent.add(sun1);
		parent.add(sun2);
		parent.add(sun3);		
		
		return parent;		
	}

	public void setDisConnMysql() {
		String v[][] = null;
		String vt[] = {"","","","մϴ."};		
		m_df_typeM = new DefaultTableModel(v, vt);
		mysqlTypeTable.setModel(m_df_typeM);
		mysqlDataTable.setModel(new MysqlTypeDefaultModel());
		
		try {
			mTree_model.setRoot(mysql_DisconnTreeModel());
		} catch (Exception e) {
			System.out.println("Mysql Tree ");
		}		
		
	}
	
	public void checkConn()
	{ 
		if(ora_con_bl == true & m_con_bl== true)
		{
			bt_MysqlToOracle.setEnabled(true);
			bt_OracleToMysql.setEnabled(true);
		}else
		{
			bt_MysqlToOracle.setEnabled(false);
			bt_OracleToMysql.setEnabled(false);
			
		}
		
		
	}
	

	public void setDisConnOracle() {
		String v[][] = null;
		String vt[] = {"","","","մϴ."};
		oracleType.setModel(new DefaultTableModel(v,vt));
		oracleData.setModel(new MysqlTypeDefaultModel());
		
		try {
			oraTree_model.setRoot(mysql_DisconnTreeModel());
		} catch (Exception e) {
			System.out.println("Mysql Tree ");
		}		
		
	}
	
	
	
	
	public void setOracleTree()
	{
		ora_tables = new Vector();
		oraTree_model = (DefaultTreeModel)oracleTree.getModel();
		try {
			oraTree_model.setRoot(oracle_TreeModel(Oracle_conn, ora_dbName));
		} catch (Exception e) {
			System.out.println("Oracle Tree ");
			// e.printStackTrace();
		}	
		

		setOracleDataTable();
		setOracleTypeTable();
		
	}
	

	public DefaultMutableTreeNode oracle_TreeModel(Connection con, String dbName) throws Exception
	{
		DefaultMutableTreeNode parent = new DefaultMutableTreeNode(dbName);

		stmt = con.createStatement();
		
		query="select * from tab";
		rs = stmt.executeQuery(query);
		ora_tables.clear();
		while(rs.next())
		{
			OracleTable = rs.getString(1);
			if(!OracleTable.substring(0, 4).equals("BIN$"))
			{
				ora_tables.add(OracleTable.toUpperCase());
				parent.add(new DefaultMutableTreeNode(OracleTable));
			}
		}
		
		
		return parent;		
	}
	
	Vector voraData=null,voraTitle=null;  //  @jve:decl-index=0:
	public void setOracleDataTable()
	{
		ora_dataDao = new OracleDataDao(ora_logData, OracleTable);
	
		voraData = ora_dataDao.getOracleData();
		voraTitle = ora_dataDao.getOracleTitleData();
		
		ora_df_DataM = new DefaultTableModel(voraData, voraTitle);
		oracleData.setModel(ora_df_DataM);
		
		if(ora_dataDao.conn!=null)
			ora_dataDao.conClose();
	}


	Vector voraType=null, voraHeader=null;

	private JScrollPane jScrollPane = null;

	private JScrollPane jScrollPane1 = null;

	private JScrollPane jScrollPane2 = null;
	public void setOracleTypeTable()
	{
		ora_typeDao = new OracleTypeDao(ora_logData, OracleTable);	

		voraType = ora_typeDao.getTypeDate();
		voraHeader = ora_typeDao.getTypeTitle();
		
		ora_df_TypeM = new DefaultTableModel(voraType, voraHeader);
		oracleType.setModel(ora_df_TypeM);
		
		if(ora_typeDao.conn!=null)
			ora_typeDao.conClose();
	}
	
	
	public boolean checkOracleTable(String mTable)
	{
		boolean check = false;
		
		for(int i=0;i<ora_tables.size();i++)
		{
			if(mTable.toUpperCase().equals((String)ora_tables.get(i)))
			{
				check=true;
			}
		}
		
		return check;
	}
	
	public boolean checkMysqlTable(String oraTable)
	{
		boolean check = false;
		
		for(int i=0;i<m_tables.size();i++)
		{
			if(oraTable.toUpperCase().equals((String)m_tables.get(i)))
			{
				check=true;
			}
		}
		
		return check;
	}
	
	
	public void mysqlTo_oralce()
	{
		moTable = JOptionPane.showInputDialog("ϰ  ̺ Էϼ", MysqlTable);
		if(moTable==null)
		{
			dbStatus.append("\nϿϴ.");		
		}else if(moTable.equals(""))
		{
			dbStatus.append("\nԷ ϴ.");		
		}else
		{
			while(checkOracleTable(moTable))
			{
				moTable = JOptionPane.showInputDialog("̹ ϴ ̺Դϴ.\nٸ  ̺ Էϼ", moTable);
			}
			
			try {
				create_moTable = new CreateMysqlToOracleTable(m_logData, ora_logData, MysqlTable, moTable);
			} catch (Exception e) {
				JOptionPane.showMessageDialog(null, "Mysql Oracle ̺ ","",1);
				e.printStackTrace();
			}		
			dbStatus.append("\nOracle DB "+moTable+"  ̺ Ϸ. ");
			
			
			try {
				insert_moData = new InsertData_MysqlToOracle(m_logData, ora_logData, MysqlTable, moTable);
			} catch (Exception e) {
				dbStatus.append("\nMysql Oracle  Է½ ");
				JOptionPane.showMessageDialog(null, "Mysql Oracle  Է½ ","",1);
				e.printStackTrace();
			}
			
			
			dbStatus.append("\nOracle DB "+moTable+"  ̺ Data Ϸ. ");
			
			
			setOracleTree();
		}
		
	}
	
	
	
	
	
	
	
	public void oracleTo_mysql()
	{
		omTable = JOptionPane.showInputDialog("ϰ  ̺ Էϼ", OracleTable);
		if(omTable==null)
		{
			dbStatus.append("\nϿϴ. ");
			
		}else if(omTable.equals(""))
		{
			dbStatus.append("\nԷ ϴ.");
			
		}else{
		
		
			while(checkMysqlTable(omTable))
			{
				omTable = JOptionPane.showInputDialog("̹ ϴ ̺Դϴ.\nٸ  ̺ Էϼ", omTable);
			}
	
			try {
				create_omTable = new CreateOracleToMysqlTable(ora_logData, m_logData, OracleTable, omTable);
			} catch (Exception e1) {
				// TODO ڵ  catch 
				e1.printStackTrace();
			}
			
			dbStatus.append("\nMysql DB "+omTable+"  ̺ Ϸ. ");
			
			
			try {
				insert_omData=new InsertData_OracleToMysql(ora_logData, m_logData, OracleTable, omTable);
			} catch (Exception e) {
				// TODO ڵ  catch 
				e.printStackTrace();
			}
			
			dbStatus.append("\nMysql DB "+omTable+"  ̺ Data Ϸ. ");
			
			setMysqlTree();
		
		}
	}
	
	
	
	

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

	
	
	
	
	
	
	
	
	
	/**
	 * This method initializes mysqlPanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getMysqlPanel() {
		if (mysqlPanel == null) {
			mysql_title = new JLabel();
			mysql_title.setBounds(new Rectangle(84, 5, 64, 29));
			mysql_title.setFont(new Font("Dialog", Font.BOLD, 12));
			mysql_title.setText("   MySQL");
			lb_DB = new JLabel();
			lb_DB.setBounds(new Rectangle(20, 148, 59, 20));
			lb_DB.setText(" DB Name");
			lb_pw = new JLabel();
			lb_pw.setBounds(new Rectangle(12, 120, 69, 19));
			lb_pw.setText("PassWord");
			lb_ID = new JLabel();
			lb_ID.setBounds(new Rectangle(39, 92, 38, 15));
			lb_ID.setText("   ID");
			lb_port = new JLabel();
			lb_port.setBounds(new Rectangle(40, 61, 37, 19));
			lb_port.setText("  Port");
			lb_ip = new JLabel();
			lb_ip.setBounds(new Rectangle(43, 38, 33, 18));
			lb_ip.setText("  IP");
			mysqlPanel = new JPanel();
			mysqlPanel.setLayout(null);
			mysqlPanel.setLocation(new Point(7, 7));
			mysqlPanel.setSize(new Dimension(230, 230));
			mysqlPanel.add(lb_ip, null);
			mysqlPanel.add(lb_port, null);
			mysqlPanel.add(lb_ID, null);
			mysqlPanel.add(lb_pw, null);
			mysqlPanel.add(lb_DB, null);
			mysqlPanel.add(getMysql_ip(), null);
			mysqlPanel.add(getMysql_port(), null);
			mysqlPanel.add(getMysql_id(), null);
			mysqlPanel.add(getMysql_pw(), null);
			mysqlPanel.add(getMysql_dbname(), null);
			mysqlPanel.add(getMysql_conn(), null);
			mysqlPanel.add(getMysql_exit(), null);
			mysqlPanel.add(mysql_title, null);
		}
		return mysqlPanel;
	}

	/**
	 * This method initializes mysql_ip	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getMysql_ip() {
		if (mysql_ip == null) {
			mysql_ip = new JTextField();
			mysql_ip.setLocation(new Point(85, 37));
			mysql_ip.setSize(new Dimension(120, 20));
		}
		return mysql_ip;
	}

	/**
	 * This method initializes mysql_port	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getMysql_port() {
		if (mysql_port == null) {
			mysql_port = new JTextField("3306");
			mysql_port.setLocation(new Point(85, 62));
			mysql_port.setSize(new Dimension(80, 20));
		}
		return mysql_port;
	}

	/**
	 * This method initializes mysql_id	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getMysql_id() {
		if (mysql_id == null) {
			mysql_id = new JTextField();
			mysql_id.setLocation(new Point(85, 90));
			mysql_id.setSize(new Dimension(120, 20));
		}
		return mysql_id;
	}

	/**
	 * This method initializes mysql_pw	
	 * 	
	 * @return javax.swing.JPasswordField	
	 */
	private JPasswordField getMysql_pw() {
		if (mysql_pw == null) {
			mysql_pw = new JPasswordField();
			mysql_pw.setLocation(new Point(85, 119));
			mysql_pw.setSize(new Dimension(120, 20));
		}
		return mysql_pw;
	}

	/**
	 * This method initializes mysql_dbname	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getMysql_dbname() {
		if (mysql_dbname == null) {
			mysql_dbname = new JTextField();
			mysql_dbname.setLocation(new Point(85, 149));
			mysql_dbname.setSize(new Dimension(120, 20));
		}
		return mysql_dbname;
	}

	/**
	 * This method initializes mysql_conn	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getMysql_conn() {
		if (mysql_conn == null) {
			mysql_conn = new JButton();
			mysql_conn.setText("MySQL ");
			mysql_conn.setSize(new Dimension(110, 25));
			mysql_conn.setLocation(new Point(7, 185));
			mysql_conn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {

					m_ip = mysql_ip.getText().trim();
					m_port = mysql_port.getText().trim();
					m_id = mysql_id.getText().trim();
					m_pw = mysql_pw.getText().trim();
					m_dbName = mysql_dbname.getText().trim();
					
					
					m_logData = new MysqlLoginData();
					
					m_logData.setM_dbName(m_dbName);
					m_logData.setM_id(m_id);
					m_logData.setM_ip(m_ip);
					m_logData.setM_port(m_port);
					m_logData.setM_pw(m_pw);
					
					
					
					
					if(m_ip.equals("") | m_port.equals("") | m_id.equals("") | m_dbName.equals(""))
					{
						JOptionPane.showMessageDialog(null, "ԷԴϴ.","",1);
						dbStatus.append("\nMySQL :  ԷԴϴ.");
					}else
					{
						try
						{
							MySQL_pool = DBConnectionKisun.getInstance("mysql", m_logData.getM_ip(), m_logData.getM_port(), m_logData.getM_dbName(), m_logData.getM_id(), m_logData.getM_pw());
							MySQL_conn=MySQL_pool.getConnection();
							dbStatus.append("\nMySQL : Ἲ");
							
							mysql_exit.setEnabled(true);
							mysql_conn.setEnabled(false);
														
							m_con_bl = true;
							
							
							setMysqlTree();
							
							checkConn();
							
							
							
							
							
							
							
							
							
							
							
							
							
							
							
							
							
							
							
							
							
						}catch(Exception ex)
						{
							System.out.println(ex.getMessage());
							JOptionPane.showMessageDialog(null, "","",1);
						}
					}
// TODO Auto-generated Event stub actionPerformed()					System.out.println("actionPerformed()"); 
				}
			});
		}
		return mysql_conn;
	}

	/**
	 * This method initializes mysql_exit	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getMysql_exit() {
		if (mysql_exit == null) {
			mysql_exit = new JButton();
			mysql_exit.setText("MySQL ݱ");			
			mysql_exit.setSize(new Dimension(110, 25));
			mysql_exit.setLocation(new Point(113, 185));
			
			mysql_exit.setEnabled(false);
			
			mysql_exit.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
										
					mysql_exit.setEnabled(false);
					mysql_conn.setEnabled(true);
					
					setDisConnMysql();
					
					if(MySQL_conn != null)
					{
						try {
//							MySQL_conn.close();
							MySQL_pool.freeConnection(MySQL_conn);
						} catch (Exception e1) {
							// TODO ڵ  catch 
							e1.printStackTrace();
						}
					}
					m_con_bl=false;
					checkConn();
					dbStatus.append("\nMySQL :  ");
					
				}
			});
		}
		return mysql_exit;
	}

	/**
	 * This method initializes mysqlTree	
	 * 	
	 * @return javax.swing.JTree	
	 */
	private JTree getMysqlTree() {
		if (mysqlTree == null) {

			DefaultMutableTreeNode parent = new DefaultMutableTreeNode("MySQL DB");
			DefaultMutableTreeNode sun1 = new DefaultMutableTreeNode("");
			DefaultMutableTreeNode sun2 = new DefaultMutableTreeNode("̺");
			DefaultMutableTreeNode sun3 = new DefaultMutableTreeNode("ϼ");
			parent.add(sun1);
			parent.add(sun2);
			parent.add(sun3);
			mTree_model = new DefaultTreeModel(parent);
			
			mysqlTree = new JTree(mTree_model);
			mysqlTree.addTreeSelectionListener(new MysqlSelection());
		}
		return mysqlTree;
	}

	/**
	 * This method initializes mysql_card	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getMysql_card() {
		if (mysql_card == null) {
			mysql_card = new JPanel();
			mysql_card.setLayout(new BorderLayout());
			mysql_card.setLocation(new Point(405, 9));
			mysql_card.setSize(new Dimension(581, 287));
			mysql_card.add(getMysqlTab(), BorderLayout.CENTER);
		}
		return mysql_card;
	}

	/**
	 * This method initializes mysqlTab	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */
	private JTabbedPane getMysqlTab() {
		if (mysqlTab == null) {
			mysqlTab = new JTabbedPane();
			mysqlTab.addTab("Type", null, getMysqlType(), null);
			mysqlTab.addTab("Data", null, getMysqlDataScroll(), null);
		}
		return mysqlTab;
	}

	/**
	 * This method initializes mysqlType	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getMysqlType() {
		if (mysqlType == null) {
			mysqlType = new JScrollPane();
			mysqlType.setViewportView(getMysqlTypeTable());
		}
		return mysqlType;
	}

	/**
	 * This method initializes mysqlTypeTable	
	 * 	
	 * @return javax.swing.JTable	
	 */
	
	
	private JTable getMysqlTypeTable() {
		if (mysqlTypeTable == null) {
			
			mysqlTypeTable = new JTable(mtdm);
		}
		return mysqlTypeTable;
	}

	/**
	 * This method initializes mysqlDataScroll	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getMysqlDataScroll() {
		if (mysqlDataScroll == null) {
			mysqlDataScroll = new JScrollPane();
			mysqlDataScroll.setViewportView(getMysqlDataTable());
		}
		return mysqlDataScroll;
	}

	/**
	 * This method initializes mysqlDataTable	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getMysqlDataTable() {
		if (mysqlDataTable == null) {

			mysqlDataTable = new JTable(mtdm);
		}
		return mysqlDataTable;
	}

	/**
	 * This method initializes dbStatus	
	 * 	
	 * @return javax.swing.JTextArea	
	 */
	private JTextArea getDbStatus() {
		if (dbStatus == null) {
			dbStatus = new JTextArea();
			dbStatus.setText("*  âԴϴ. *");
		}
		return dbStatus;
	}

	/**
	 * This method initializes OraclePanel	
	 * 	
	 * @return javax.swing.JPanel	
	 */
	private JPanel getOraclePanel() {
		if (OraclePanel == null) {
			jLabel5 = new JLabel();
			jLabel5.setBounds(new Rectangle(14, 145, 63, 20));
			jLabel5.setText(" DB Name");
			jLabel4 = new JLabel();
			jLabel4.setBounds(new Rectangle(9, 118, 67, 21));
			jLabel4.setText(" PassWord");
			jLabel3 = new JLabel();
			jLabel3.setBounds(new Rectangle(52, 99, 23, 16));
			jLabel3.setText(" ID");
			jLabel2 = new JLabel();
			jLabel2.setBounds(new Rectangle(41, 73, 34, 20));
			jLabel2.setText(" Port");
			jLabel1 = new JLabel();
			jLabel1.setBounds(new Rectangle(54, 47, 21, 18));
			jLabel1.setText(" IP");
			jLabel = new JLabel();
			jLabel.setBounds(new Rectangle(77, 12, 74, 29));
			jLabel.setFont(new Font("Dialog", Font.BOLD, 12));
			jLabel.setText("     Oracle");
			OraclePanel = new JPanel();
			OraclePanel.setLayout(null);
			OraclePanel.setLocation(new Point(10, 411));
			OraclePanel.setSize(new Dimension(230, 230));
			OraclePanel.add(jLabel, null);
			OraclePanel.add(jLabel1, null);
			OraclePanel.add(jLabel2, null);
			OraclePanel.add(jLabel3, null);
			OraclePanel.add(jLabel4, null);
			OraclePanel.add(jLabel5, null);
			OraclePanel.add(getOracle_conn(), null);
			OraclePanel.add(getOracle_exit(), null);
			OraclePanel.add(getOracle_ip(), null);
			OraclePanel.add(getOracle_port(), null);
			OraclePanel.add(getOracle_id(), null);
			OraclePanel.add(getOracle_pw(), null);
			OraclePanel.add(getOracle_dbname(), null);
		}
		return OraclePanel;
	}

	/**
	 * This method initializes oracle_conn	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getOracle_conn() {
		if (oracle_conn == null) {
			oracle_conn = new JButton();
			oracle_conn.setBounds(new Rectangle(10, 181, 106, 32));
			oracle_conn.setText("Oracle ");
			oracle_conn.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					

					ora_ip = oracle_ip.getText().trim();
					ora_port = oracle_port.getText().trim();
					ora_id = oracle_id.getText().trim();
					ora_pw = oracle_pw.getText().trim();
					ora_dbName = oracle_dbname.getText().trim();
					
					ora_logData = new OracleLoginData();
					ora_logData.setOracle_dbname(ora_dbName);
					ora_logData.setOracle_id(ora_id);
					ora_logData.setOracle_ip(ora_ip);
					ora_logData.setOracle_port(ora_port);
					ora_logData.setOracle_pw(ora_pw);


					if(ora_ip.equals("") | ora_port.equals("") | ora_id.equals("") | ora_dbName.equals(""))
					{
						dbStatus.append("\nMySQL :  ԷԴϴ.");
					}else
					{
					
						try {
							Oracle_pool = DBKisunOracle.getInstance(ora_ip, ora_port, ora_dbName, ora_id,ora_pw);
							Oracle_conn = Oracle_pool.getConnection();
							dbStatus.append("\nOracle : Ἲ");
							oracle_conn.setEnabled(false);
							oracle_exit.setEnabled(true);
							
							ora_con_bl=true;
							

							setOracleTree();

							checkConn();
							
							
							
							
							 
							
							
							
							
							
						} catch (Exception e1) {
							e1.printStackTrace();
							System.out.println(e1.getStackTrace());
							JOptionPane.showMessageDialog(null, "","",1);
						}
						
					}
					
					
				}
			});
		}
		return oracle_conn;
	}

	/**
	 * This method initializes oracle_exit	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getOracle_exit() {
		if (oracle_exit == null) {
			oracle_exit = new JButton();
			oracle_exit.setBounds(new Rectangle(117, 181, 106, 32));
			oracle_exit.setText("Oracle ݱ");
			oracle_exit.setEnabled(false);
			oracle_exit.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					

					if(Oracle_conn != null)
					{
						try {
//							Oracle_conn.close();
							Oracle_pool.freeConnection(Oracle_conn);
						} catch (Exception e1) {
							// TODO ڵ  catch 
							e1.printStackTrace();
						}
					}
					
					setDisConnOracle();
					
					oracle_conn.setEnabled(true);
					oracle_exit.setEnabled(false);
					
					ora_con_bl=false;
					dbStatus.append("\nOracle : ");

					checkConn();
					
					
				}
			});
		}
		return oracle_exit;
	}

	/**
	 * This method initializes oracle_ip	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getOracle_ip() {
		if (oracle_ip == null) {
			oracle_ip = new JTextField();
			oracle_ip.setBounds(new Rectangle(85, 49, 111, 19));
		}
		return oracle_ip;
	}

	/**
	 * This method initializes oracle_port	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getOracle_port() {
		if (oracle_port == null) {
			oracle_port = new JTextField("1521");
			oracle_port.setBounds(new Rectangle(85, 75, 90, 19));
		}
		return oracle_port;
	}

	/**
	 * This method initializes oracle_id	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getOracle_id() {
		if (oracle_id == null) {
			oracle_id = new JTextField();
			oracle_id.setSize(new Dimension(112, 18));
			oracle_id.setLocation(new Point(85, 98));
		}
		return oracle_id;
	}

	/**
	 * This method initializes oracle_pw	
	 * 	
	 * @return javax.swing.JPasswordField	
	 */
	private JPasswordField getOracle_pw() {
		if (oracle_pw == null) {
			oracle_pw = new JPasswordField();
			oracle_pw.setBounds(new Rectangle(85, 119, 112, 19));
		}
		return oracle_pw;
	}

	/**
	 * This method initializes oracle_dbname	
	 * 	
	 * @return javax.swing.JTextField	
	 */
	private JTextField getOracle_dbname() {
		if (oracle_dbname == null) {
			oracle_dbname = new JTextField();
			oracle_dbname.setBounds(new Rectangle(85, 145, 113, 21));
		}
		return oracle_dbname;
	}

	/**
	 * This method initializes oracleTree	
	 * 	
	 * @return javax.swing.JTree	
	 */
	private JTree getOracleTree() {
		if (oracleTree == null) {
			DefaultMutableTreeNode parent = new DefaultMutableTreeNode("Oracle DB");
			DefaultMutableTreeNode sun1 = new DefaultMutableTreeNode("");
			DefaultMutableTreeNode sun2 = new DefaultMutableTreeNode("̺");
			DefaultMutableTreeNode sun3 = new DefaultMutableTreeNode("ϼ");
			parent.add(sun1);
			parent.add(sun2);
			parent.add(sun3);
			oraTree_model = new DefaultTreeModel(parent);
			
			oracleTree = new JTree(oraTree_model);
			oracleTree.addTreeSelectionListener(new OracleSelection());
		}
		return oracleTree;
	}

	/**
	 * This method initializes oracleTab	
	 * 	
	 * @return javax.swing.JTabbedPane	
	 */
	private JTabbedPane getOracleTab() {
		if (oracleTab == null) {
			oracleTab = new JTabbedPane();
			oracleTab.setLocation(new Point(405, 350));
			oracleTab.setSize(new Dimension(582, 287));
			oracleTab.addTab("Type", null, getOracleTypeScroll(), null);
			oracleTab.addTab("Data", null, getOracleDataScroll(), null);
		}
		return oracleTab;
	}

	/**
	 * This method initializes oracleTypeScroll	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getOracleTypeScroll() {
		if (oracleTypeScroll == null) {
			oracleTypeScroll = new JScrollPane();
			oracleTypeScroll.setViewportView(getOracleType());
		}
		return oracleTypeScroll;
	}

	/**
	 * This method initializes oracleType	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getOracleType() {
		if (oracleType == null) {
			oracleType = new JTable(mtdm);
		}
		return oracleType;
	}

	/**
	 * This method initializes oracleDataScroll	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getOracleDataScroll() {
		if (oracleDataScroll == null) {
			oracleDataScroll = new JScrollPane();
			oracleDataScroll.setViewportView(getOracleData());
		}
		return oracleDataScroll;
	}

	/**
	 * This method initializes oracleData	
	 * 	
	 * @return javax.swing.JTable	
	 */
	private JTable getOracleData() {
		if (oracleData == null) {
			oracleData = new JTable(mtdm);
		}
		return oracleData;
	}

	/**
	 * This method initializes bt_MysqlToOracle	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBt_MysqlToOracle() {
		if (bt_MysqlToOracle == null) {
			bt_MysqlToOracle = new JButton();
			bt_MysqlToOracle.setBounds(new Rectangle(433, 305, 139, 30));
			bt_MysqlToOracle.setText("Mysql To Oracle");
			bt_MysqlToOracle.setEnabled(false);
			bt_MysqlToOracle.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					
					
					
					dbStatus.append("\nڵȯ : Mysql -> Oracle ");
					
					mysqlTo_oralce();
					
				}
			});
		}
		return bt_MysqlToOracle;
	}

	/**
	 * This method initializes bt_OracleToMysql	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getBt_OracleToMysql() {
		if (bt_OracleToMysql == null) {
			bt_OracleToMysql = new JButton();
			bt_OracleToMysql.setText("Oracle To Mysql");
			bt_OracleToMysql.setLocation(new Point(618, 305));
			bt_OracleToMysql.setSize(new Dimension(139, 30));
			bt_OracleToMysql.setEnabled(false);
			bt_OracleToMysql.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(java.awt.event.ActionEvent e) {
					
					

					dbStatus.append("\nڵȯ : Oracle -> Mysql ");
					
					
					oracleTo_mysql();
					
				}
			});
		}
		return bt_OracleToMysql;
	}

	/**
	 * This method initializes jScrollPane	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane() {
		if (jScrollPane == null) {
			jScrollPane = new JScrollPane();
			jScrollPane.setLocation(new Point(8, 243));
			jScrollPane.setSize(new Dimension(233, 158));
			jScrollPane.setViewportView(getDbStatus());
		}
		return jScrollPane;
	}

	/**
	 * This method initializes jScrollPane1	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane1() {
		if (jScrollPane1 == null) {
			jScrollPane1 = new JScrollPane();
			jScrollPane1.setSize(new Dimension(147, 287));
			jScrollPane1.setLocation(new Point(253, 7));
			jScrollPane1.setViewportView(getMysqlTree());
		}
		return jScrollPane1;
	}

	/**
	 * This method initializes jScrollPane2	
	 * 	
	 * @return javax.swing.JScrollPane	
	 */
	private JScrollPane getJScrollPane2() {
		if (jScrollPane2 == null) {
			jScrollPane2 = new JScrollPane();
			jScrollPane2.setLocation(new Point(253, 350));
			jScrollPane2.setSize(new Dimension(146, 287));
			jScrollPane2.setViewportView(getOracleTree());
		}
		return jScrollPane2;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				MainFrm thisClass = new MainFrm();
				thisClass.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
				thisClass.setVisible(true);
			}
		});
	}

	/**
	 * This is the default constructor
	 */
	public MainFrm() {
		super();
		mtdm = new MysqlTypeDefaultModel();
		initialize();
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(1011, 681);
		this.setContentPane(getJContentPane());
		this.setTitle("JFrame");
		
		
	}

	/**
	 * This method initializes jContentPane
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			jContentPane = new JPanel();
			jContentPane.setLayout(null);
			jContentPane.add(getMysqlPanel(), null);
			jContentPane.add(getMysql_card(), null);
			jContentPane.add(getOraclePanel(), null);
			jContentPane.add(getOracleTab(), null);
			jContentPane.add(getBt_MysqlToOracle(), null);
			jContentPane.add(getBt_OracleToMysql(), null);
			jContentPane.add(getJScrollPane(), null);
			jContentPane.add(getJScrollPane1(), null);
			jContentPane.add(getJScrollPane2(), null);
		}
		return jContentPane;
	}

	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	

	class MysqlSelection implements TreeSelectionListener
	{

		public void valueChanged(TreeSelectionEvent te) {
			if(m_con_bl)
			{
				TreePath path = te.getPath();			
				DefaultMutableTreeNode node = (DefaultMutableTreeNode)path.getLastPathComponent();
				String str = node.toString();
				if(!str.equals(m_dbName))
				{
					MysqlTable = str;

					setMysqlTypeTable();
					setMysqlDataTable();
				}
			}
			
		}
		
	}
	
	

	class OracleSelection implements TreeSelectionListener
	{

		public void valueChanged(TreeSelectionEvent te) {
			if(ora_con_bl)
			{
				TreePath path = te.getPath();			
				DefaultMutableTreeNode node = (DefaultMutableTreeNode)path.getLastPathComponent();
				String str = node.toString();
				if(!str.equals(ora_dbName))
				{
					OracleTable = str;

					setOracleDataTable();
					setOracleTypeTable();
				}
			}
			
		}
		
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
}  //  @jve:decl-index=0:visual-constraint="-83,23"
