package visualDB;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;

import javax.swing.JOptionPane;

public class CreateMysqlToOracleTable {

	DBConnectionKisun pool=null;
	DBKisunOracle ora_pool=null;
	Connection conn=null;
	Statement stmt=null;
	ResultSet rs = null;
	ResultSetMetaData rsmd=null;
	String query;
	
	
	/**
	 * ο Ÿ Ÿ 158columnType޼ҵ switch ߰Ű 
	 * 97 ColumnSize  Ⱦ  .
	 */
	

	CreateMysqlToOracleTable(MysqlLoginData m_log, OracleLoginData ora_log, String mTable, String oraTable) throws Exception{
		// db, ip, portȣ, db, user,  
			pool = DBConnectionKisun.getInstance("mysql",m_log.getM_ip(), m_log.getM_port(), m_log.getM_dbName(), m_log.getM_id(),m_log.getM_pw());
			conn = pool.getConnection();
			stmt = conn.createStatement();
			
			System.out.println(" Ϸ!\n======================");
			String str = makeTable(mTable,oraTable);
			System.out.println(str);

			if(conn != null)
			{
				pool.freeConnection(conn, stmt);
			}
			
			ora_pool = DBKisunOracle.getInstance(ora_log.getOracle_ip(),ora_log.getOracle_port(), ora_log.getOracle_dbname(), ora_log.getOracle_id(),ora_log.getOracle_pw());
			conn = ora_pool.getConnection();
			stmt = conn.createStatement();
						
			stmt.execute(str);

			System.out.println("̺ Ϸ");
			
			query="select * from tab";
			rs = stmt.executeQuery(query);
			while(rs.next())
			System.out.println(rs.getString(1));
			
			if(conn != null)
			{
				ora_pool.freeConnection(conn, stmt);
			}
			
		
	}
	
	
	CreateMysqlToOracleTable(){
		
	}
	
	public String makeTable(String table, String newTable)
	{
		query="select * from "+table;	
		String create_table = "create table "+newTable+"(";
		
		try {
			rs = stmt.executeQuery(query);
			rsmd = rs.getMetaData(); 
			System.out.println("getTableName  : "+rsmd.getTableName(1));
			int columnCount = rsmd.getColumnCount();
			System.out.println("columnCount : "+columnCount);
			int a=1;
			while(a<=columnCount)
			{
				System.out.println("----------------- ");
				System.out.print("\tgetCatalogName : "+rsmd.getColumnName(a));
				create_table =create_table+ checkName(rsmd.getColumnName(a))+" ";	//++++++++++ ʵ  +++++++++++++++++++++
				System.out.print("\tgetColumnTypeName : "+rsmd.getColumnTypeName(a));
				System.out.print("\tgetColumnType : "+rsmd.getColumnType(a));

				System.out.print("\tgetPrecision(10ڸ) : "+rsmd.getPrecision(a));
				System.out.print("\tgetScale(Ҽ) : "+rsmd.getScale(a));
				
				
				create_table =create_table+ columnType(rsmd.getColumnType(a),rsmd.getPrecision(a), rsmd.getScale(a), rsmd.getColumnDisplaySize(a) );	//++++++++++ ColumnType  +++++++++++++++++++++
				System.out.print("\tgetColumnDisplaySize : "+rsmd.getColumnDisplaySize(a));
				
				
				
//				if(rsmd.getColumnType(a)!= 91 )	// dateŸ Size  -- long(text)Ÿ varchar2 
//				{
//					if(rsmd.getColumnDisplaySize(a)>4000)
//						create_table =create_table+"(4000)";	//++++++++++ ColumnSize  +++++++++++++++++++++						
//					else
//						create_table =create_table+"("+ rsmd.getColumnDisplaySize(a)+")";	//++++++++++ ColumnSize  +++++++++++++++++++++
//					
//				}
				
				
				if(rsmd.isNullable(a)==ResultSetMetaData.columnNoNulls)
				{
					System.out.println("\tNo Null");
					create_table =create_table+ " not null ";	//++++++++++ not null  ++++++++++++++++
				}
				else if(rsmd.isNullable(a)==ResultSetMetaData.columnNullable)
					System.out.println("\tNull Able");
				else if(rsmd.isNullable(a)==ResultSetMetaData.columnNullableUnknown)
					System.out.println("\tNull Don't know");


				if(a!=columnCount)
				create_table =create_table+ ", ";	//++++++++++ comma  ++++++++++++++++
				
				a++;
			}		
			
			
			DatabaseMetaData md = conn.getMetaData();
			ResultSet rs1 = md.getPrimaryKeys(null, null, table);
			if(rs1.next())
			{
				create_table =create_table+", primary key(";	//+++++++++++++ primary key ++++++++++++++++++			
				//ResultSetMetaData rsmd1 = rs1.getMetaData();
				create_table =create_table+rs1.getString(4)+"))";	//+++++++++++++++++++++++++++++++
			}else
			{
				create_table =create_table+")";	
			}
			if(rs1 != null)
				rs1.close();
			
			
		} catch (SQLException e) {
			e.printStackTrace();
		}
		
		return create_table;
	}
		
	private String checkName(String columnName) {
		String check_str=columnName.toUpperCase();
		String booking[] ={"ACCESS", "ADD", "ALL", "ALTER", "AND", "ANY", "AS", "ASC", "AUDIT", "BETWEEN", "BY", "CHAR", 
				"CHECK", "CLUSTER", "CLOUMN","COMMENT", "COMPRESS", "CONNECT","CREATE", "CURRENT", "DATE", 
				"DECIMAL", "DEFAULT", "DELETE", "DESC", "DISTINCT", "DROP", "ELSE", "EXCLUSIVE", "EXISTS", 
				"FILE", "FLOAT", "FOR", "FROM", "GRANT", "GROUP", "HAVING", "IDENTIFIED", "IMMEDIATE", "IN", 
				"INCREMENT", "INDEX", "INTIAL", "INSERT", "INTEGER", "INTERSECT", "INTO", "IS", "LEVEL", "LIKE", 
				"LOCK", "LONG", "MAXEXTENTS", "MINUS", "MODE", "MODIFY", "NOAUDIT", "NOCOMPRESS", "NOT", "NOWAIT",  
				"NULL", "NUMBER", "OF", "OFFLINE", "ON", "OPTION", "OR", "ORDER", "PCTREE", "PRIOR", 
				"PRIVILEGES", "PUBLIC", "RAW", "RENAME", "RESOURCE", "REVOKE", "ROW", "ROWID", "ROWNUM", "ROWS", 
				"SELECT", "SESSION", "SET", "SHARE", "SIZE", "SMALLINT", "START", "SUCESSFUL", "SYNONYM", "SYSDATE", 
				"TABLE", "THEN", "TO", "TRIGGER", "UID", "UNION", "UNIQUE", "UPDATE", "USER", "VALIDATE", 
				"VALUES", "VARCHAR", "VARCHAR2", "VIEW", "WHENEVER", "WHERE", "WITH"};
		for(int i=0;i<booking.length;i++)
		{
			if(check_str.equals(booking[i]))
				check_str=JOptionPane.showInputDialog(booking[i]+" Ŭ  ȵ \n ʵ Էּ(̸ ٲ Ÿ, )");	
			// ȵǴ ̸ ޽ڽ Է¹ޱ 
		}
		return check_str;
	}

	private String columnType(int columnType, int ten, int underPoint, int size) {
		String col_type="";
		int length = size>4000 ? 4000 : size;
		int under = underPoint==0 ? 0 : 8;
		
		
		switch(columnType)
		{
		case -1: col_type="varchar2("+length+")";	break;	// text > long
		case 1: col_type="char("+length+")";	break;	// text > long
		case 4: col_type="number("+ten+", "+under+")";	break;	// int
		case 5: col_type="number("+ten+", "+under+")";	break;	// small_int
		case 6: col_type="number("+ten+", "+under+")";	break;	// small_int
		case 7: col_type="number("+ten+", "+under+")";	break;	// float
		case 8: col_type="number("+ten+", "+under+")";	break;	// double
		case 12: col_type="varchar2("+length+")";	break;	// string
		case 91: col_type="date";	break;	// date
		case 92: col_type="date";	break;	// time
		case 93: col_type="date";	break;	// datetime
		default : col_type="default"; 	break;
		}
		
		return col_type;
	}

	public static void main(String[] args) {
		new CreateMysqlToOracleTable();
	}
}
